#!/bin/sh

while [ -n "$1" ]
do
    case "$1" in
        --with-dns)  DNS="y" ;;
        --build-dns) BUILD="y" ;;
        *) echo >2 "Unkown option: $1" ;;
    esac
    shift
done

rm -f named named.rev dhcpd.conf

while read ligne
do
    if echo "$ligne" | grep "^lease" > /dev/null
    then
        echo "host {" >> dhcpd.conf
        set -- $ligne
        IP="$2"
        echo "$IP"
    fi
    if echo "$ligne" | grep "hardware ethernet" > /dev/null
    then
        echo "    $ligne" >> dhcpd.conf
    fi
    if echo "$ligne" | grep "client-hostname" > /dev/null
    then
        set -- $ligne
        Hostname=`echo $2 | sed -e "s/\"//g" -e "s/\;//"`
        if [ "$DNS" = "y" ]
        then
            echo "    $ligne" | sed "s/client-hostname/fixed-address/" >> dhcpd.conf
        else
            echo "    fixed-address $IP;" >> dhcpd.conf
        fi
        echo "}" >> dhcpd.conf

        if [ "$BUILD" = "y" ]
        then
            echo "$Hostname    IN    A    $IP" >> named
            echo "`echo $IP | cut -d. -f4`    IN    PTR    $Hostname" >> named.rev
        fi
    fi
done

exit 0
